/*

    Copyright (c) 2017 Motas Electronics Limited (J M HAYES)
    www.motas-synth.uk


    Permission is hereby granted, free of charge, to any person
    obtaining a copy of this software and any associated documentation files
    (the "Software"), to deal in the Software without restriction,
    including without limitation the rights to use, copy, modify, merge,
    publish, distribute, sublicense, and/or sell copies of the Software,
    and to permit persons to whom the Software is furnished to do so,
    subject to the following conditions:

    The above copyright notice and this permission notice shall be
    included in all copies or substantial portions of the Software.

    Any person wishing to distribute modifications to the Software is
    asked to send the modifications to the original developer so that
    they can be incorporated into the canonical version.  This is,
    however, not a binding provision of this license.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR
    ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
    CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
    WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


 *
 * */
#ifndef MOTASFIRMWARE_H
#define MOTASFIRMWARE_H


#include "QString"


class MotasUtility;
class MotasFirmware
{
public:
    MotasFirmware(MotasUtility *mainWindow);

    void test_encrypt_cbc(void);
    void generateFirmware(QString fileName);

    quint32 processBufferForMIDISend(char* outBuffer, char* buffer, quint32 originalDataLength);

    void mergeMainAndBootloader(QString fileName);

    quint32 lowLevelCreateMIDIStream(quint8* buf, quint32 size,  quint8 type, quint8 startStopContinue,
            quint8 msg0, quint8 msg1, quint8 msg2, quint8* outBuf);

    quint32 prepareSysExPacketsFromUnpacked(quint8 *outBuf, quint8 *buffer,
                                                          quint32 totalDataSize, int type, quint8 msg0, quint8 msg1, quint8 msg2 , quint8 model, quint8 channel);

    MotasUtility* motasUtility;
    void writeRawSysExFile(char* inputBuffer, const quint32 bufferLength, QString fileSaveName);
    void writeMIDIfile(char *inputBuffer, quint32 bufferLength, QString fileSaveName, int delayBetweenPackets);
};

#endif // MOTASFIRMWARE_H
